当前位置: 首页>>代码示例>>C#>>正文


C# Curve.DuplicateCurve方法代码示例

本文整理汇总了C#中Rhino.Geometry.Curve.DuplicateCurve方法的典型用法代码示例。如果您正苦于以下问题:C# Curve.DuplicateCurve方法的具体用法?C# Curve.DuplicateCurve怎么用?C# Curve.DuplicateCurve使用的例子?那么恭喜您, 这里精选的方法代码示例或许可以为您提供帮助。您也可以进一步了解该方法所在Rhino.Geometry.Curve的用法示例。


在下文中一共展示了Curve.DuplicateCurve方法的3个代码示例,这些例子默认根据受欢迎程度排序。您可以为喜欢或者感觉有用的代码点赞,您的评价将有助于系统推荐出更棒的C#代码示例。

示例1: Edge

 public Edge(Brep[] C, Curve i)
 {
     BasisCurve = i.DuplicateCurve();
 }
开发者ID:MengdiGuo,项目名称:PachydermAcoustic_Rhinoceros,代码行数:4,代码来源:Classes_Edges.cs

示例2: AddCurve

    /// <summary>
    /// Adds a new, colored curve to the display list.
    /// The curve will be duplicated so changes to the 
    /// original will not affect the display.
    /// </summary>
    /// <param name="curve">Curve to add.</param>
    /// <param name="color">Color of curve.</param>
    /// <param name="thickness">Thickness of curve.</param>
    public void AddCurve(Curve curve, Color color, int thickness)
    {
      if (m_disposed) { throw new ObjectDisposedException("This CustomDisplay instance has been disposed and cannot be modified"); }
      if (curve == null) { return; }
      if (!curve.IsValid) { return; }

      CDU_Curve cdu = new CDU_Curve();
      cdu.m_curve = curve.DuplicateCurve();
      cdu.m_color = Color.FromArgb(255, color);
      cdu.m_thickness = thickness;

      m_curves.Add(cdu);
      m_clip.Union(cdu.m_curve.GetBoundingBox(false));
    }
开发者ID:jackieyin2015,项目名称:rhinocommon,代码行数:22,代码来源:rhinosdkdisplayconduitutility.cs

示例3: convCurve

        internal static IfcBoundedCurve convCurve(DatabaseIfc db, Curve crv, IfcCartesianPoint optStrt, bool twoD, out IfcCartesianPoint end)
        {
            double tol = db.Tolerance;
            end = null;
            Curve c = crv.DuplicateCurve();
            if (c.IsLinear(tol))
            {
                if (twoD)
                    end = new IfcCartesianPoint(db, new Point2d(c.PointAtEnd.X, c.PointAtEnd.Y));
                else
                    end = new IfcCartesianPoint(db, c.PointAtEnd);
                if (optStrt == null)
                {
                    if (twoD)
                        optStrt = new IfcCartesianPoint(db, new Point2d(c.PointAtStart.X, c.PointAtStart.Y));
                    else
                        optStrt = new IfcCartesianPoint(db, c.PointAtStart);
                }
                return new IfcPolyline(optStrt, end);
            }
            ArcCurve ac = c as ArcCurve;
            if (ac != null)
                return new IfcTrimmedCurve(db, ac.Arc, twoD, optStrt, out end);
            Arc arc = Arc.Unset;
            if (c.TryGetArc(out arc, tol))
                return new IfcTrimmedCurve(db, arc, twoD, optStrt, out end);

            Polyline pl = new Polyline();
            if (c.TryGetPolyline(out pl))
            {
                if (db.mRelease != ReleaseVersion.IFC2x3 && db.mRelease != ReleaseVersion.IFC4)
                {
                    if (twoD)
                        return new IfcIndexedPolyCurve(new IfcCartesianPointList2D(db, pl.ConvertAll(x => new Point2d(x.X, x.Y))));
                    else
                        return new IfcIndexedPolyCurve(new IfcCartesianPointList3D(db, pl));
                }
                List<IfcCartesianPoint> cps = new List<IfcCartesianPoint>();
                if (twoD)
                {
                    Point2d p = new Point2d(pl[0].X, pl[0].Y), n;
                    cps.Add(new IfcCartesianPoint(db, p));
                    for (int icounter = 1; icounter < pl.Count - 1; icounter++)
                    {
                        n = new Point2d(pl[icounter].X, pl[icounter].Y);
                        if (n.DistanceTo(p) > tol)
                        {
                            cps.Add(new IfcCartesianPoint(db, n));
                            p = n;
                        }
                    }
                    n = new Point2d(pl[pl.Count - 1].X, pl[pl.Count - 1].Y);
                    if (n.DistanceTo(p) > tol)
                    {
                        if (pl.IsClosed)
                            cps.Add(cps[0]);
                        else
                            cps.Add(new IfcCartesianPoint(db, n));
                    }
                }
                else
                {
                    Point3d p = pl[0], n;
                    cps.Add(new IfcCartesianPoint(db, p));
                    for (int icounter = 1; icounter < pl.Count; icounter++)
                    {
                        n = pl[icounter];
                        if (n.DistanceTo(p) > tol)
                        {
                            cps.Add(new IfcCartesianPoint(db, n));
                            p = n;
                        }
                    }
                }
                return new IfcPolyline(cps);
            }
            PolyCurve plc = c as PolyCurve;
            if (plc != null)
            {
                if (db.mRelease != ReleaseVersion.IFC2x3 && db.mRelease != ReleaseVersion.IFC4)
                {
                    IfcIndexedPolyCurve ipc = IfcIndexedPolyCurve.Convert(db, plc, twoD);
                    if (ipc != null)
                        return ipc;
                }
                return new IfcCompositeCurve(db, plc, twoD);
            }
            if (db.mRelease != ReleaseVersion.IFC2x3)
            {
                NurbsCurve nc = c as NurbsCurve;
                if (nc != null)
                {
                    if (nc.IsRational)
                        return new IfcRationalBSplineCurveWithKnots(db, nc, twoD);
                    return new IfcBSplineCurveWithKnots(db, nc, twoD);
                }
            }

            return null;
        }
开发者ID:jmirtsch,项目名称:GeometryGymIFC,代码行数:100,代码来源:IFC+B+RhinoCommon.cs


注:本文中的Rhino.Geometry.Curve.DuplicateCurve方法示例由纯净天空整理自Github/MSDocs等开源代码及文档管理平台,相关代码片段筛选自各路编程大神贡献的开源项目,源码版权归原作者所有,传播和使用请参考对应项目的License;未经允许,请勿转载。